#include <stdio.h>
#include <stdint.h>
#include "pl011_uart.h"

extern void gicInit(void);
extern uint32_t readIAR0(void);
extern void writeEOIR0(uint32_t);

extern void setTimerPeriod(uint32_t);
extern void enableTimer(void);
extern void disableTimer(void);

volatile uint32_t flag;

int main (void) {
	uartInit((void*)(0x1C090000));
	gicInit();

	printf("hello world\n");

	flag = 0;
	setTimerPeriod(0x1000);  // Generate an interrupt in 1000 ticks
	enableTimer();

	// Wait for the interrupt to arrive
	while(flag==0){}
  
	printf("Got interrupt!\n");

	return 0;
}

void fiqHandler(void) {
    uint32_t intid;
	intid = readIAR0();

	if (intid == 29) {
		flag = 1;
		disableTimer();
    } else {
		printf("Should never reach here!\n");
	}
	writeEOIR0(intid);
	return;
}