// ------------------------------------------------------------
// ARMv8-A AArch64 Startup Example
//
// Copyright Arm Ltd 2017. All rights reserved.
// ------------------------------------------------------------

  .section  BOOT,"ax"        // Define an executable ELF section, BOOT
  .align 3                   // Align to 2^3 byte boundary

  .global start64
  .type start64, "function"
start64:


  // Which core am I
  // ----------------
  MRS      x0, MPIDR_EL1
  AND      x0, x0, #0xFFFF                   // Mask off to leave Aff0 and Aff1
  CBZ      x0, boot                          // If not *.*.0.0, then go to sleep
sleep:
  WFI
  B        sleep
boot:
  

  // Disable trapping of CPTR_EL3 accesses or use of Adv.SIMD/FPU
  // -------------------------------------------------------------
  MOV      x0, #0                           // Clear all trap bits
  MSR      CPTR_EL3, x0

  
  // Configure SCR_EL3
  // ------------------
  MOV      w1, #0              // Initial value of register is unknown
  ORR      w1, w1, #(1 << 3)   // Set EA bit (SError routed to EL3)
  ORR      w1, w1, #(1 << 2)   // Set FIQ bit (FIQs routed to EL3)
  ORR      w1, w1, #(1 << 1)   // Set IRQ bit (IRQs routed to EL3)
  MSR      SCR_EL3, x1

  ISB


  // Branch to scatter loading and C library init code
  .global  __main
  B        __main


// ------------------------------------------------------------
// End of file
// ------------------------------------------------------------

